import Graphics.UI.Yahu
import Monad (when)

{- PROPSITO DEL EJEMPLO:
			- EJEMPLO DE USO DE LA BARRA DE ESTADO
			- MOSTRAR CMO SE PUEDEN USAR MENS POP-UP DE FORMA CONTEXTUAL

Proporcionamos un ejemplo de uso de la barra de estado para exponer ayuda contextual, y
de mens pop-up con acciones contextuales
-}

{----------------------------------------------------------------------------------------}

main = yahu init
 where init = do {

 	-- ventana con una barra de estado con dos campos de texto: el primero fijo de
 	--200 pixels de ancho y el segundo variable (se queda con el resto de espacio)
 	; win <- window [title =: "ejemplo de ayuda y acciones contextuales", statusBar =: [FL 200, VL 1]]

 	--ponemos algunos menuitems con mensajes de ayuda que se imprimirn en el campo 0
 	; menu <- inBarMenuAppend [title =: "&men"] win
 	; let genmenu = MnInBar menu
 	; item <- menuLabelAppend [text =: "item &1", statusBarHelp =: "esto es un MenuLabel"] genmenu
	; menuSeparatorAppend genmenu
 	; menuCheckAppend [text =: "item &2", statusBarHelp =: "esto es un MenuCheck"] genmenu
 	
 	{-marca de que vamos a cerrar. Como se produce /antes/ de que efectivamente se
 	destruya la ventana, es la nica forma de saber en el evento loseFocus (al igual
 	que en beforeDestroy) si podemos usar funcionalidad sobre la barra de estado, ya que
 	sta entra en un estado indefinido la ltima vez que se llama al manejador de loseFocus,
 	ya durante el proceso de terminacin de la aplicacin. No vale poner la marca en el
 	manejador de 'beforeDestroy', ya que ste se ejecuta /despus/ del de loseFocus-}
 	; marca <- state [value =: True]
 	; win!:on close =: do {
 		; marca!:value =: False
 		; destroy win
 		}

 	--cada objeto al que queramos dotar de ayuda contextual tendr este par de manejadores
 	; let statusactions obj str = do {
 		; obj!:on getFocus =: do {
 			--hace falta comprobar esto porque se pueden producir eventos getFocus espreos
 			--sobre los objetos Window al ser destruidos
 			; abierto <- marca?:value
 			; when abierto (win!:statusBarField 1 =: str)
 			}
 		--borramos el mensaje
 		; obj!:on loseFocus =: do {
 			; abierto <- marca?:value
 			; when abierto (win!:statusBarField 1 =: "")
 			}
 		}
 	
 	--cada objeto que queramos dotar de una accin contextual tendr esto
 	; let popupactions obj str acc = do {
 		--men pop-up
 		; popup <- popupMenu
 		--menuitem customizado
 		; popitem <- menuLabelAppend [text =: str, command =: acc] (MnPopup popup)
 		--cuando pinchemos con el botn derecho, desplegamos el men
 		; obj!:on (right mouse) =: \MouseEvent{mousePoint=p}->do {
 			; showPopupMenu popup p obj
 			--hay que devolver False porque la accin por defecto de Edit es mostrar
 			--un men contextual propio con opciones copy/paste
 			; return False
 			}
 		}
 	
 	--ponemos algunos objetos con contexto
 	; statusactions win "esto es la ventana de aplicacin"
 	; popupactions win "invierte mi ttulo" (win!:title <: reverse)
 	; ed <- edit [text =: "editor"] win
 	; statusactions ed "campo de texto multilnea"
 	; popupactions ed "maximiza la ventana" (maximize win)
 	; en <- entry_ [text =: "entry"] win
 	; statusactions en "campo de texto monolnea"
 	; popupactions en "intercambia el texto del edit y el entry" (do {
 		; str1 <- ed?:text
 		; str2 <- en?:text
 		; ed!:text =: str2
 		; en!:text =: str1
 		})
 	; but <- button [text =: "botn dummy"{-, command =: return ()-}] win
 	; statusactions but "esto es un botn"
 	; popupactions but "invierte la ayuda textual de un menuLabel"
 		(item!:statusBarHelp <: reverse)
 	; win!:layout =: but ^#^ ed ^#^ en
 	--hacemos la ventana lo suficientemente larga para que se vean los dos campos de
 	--texto de la barra de mens
 	; win!:dimX =: 400
 	}
