import Graphics.UI.Yahu

{- PROPSITO DEL EJEMPLO:
		- MOSTRAR EL USO DE MODIFICADORES DE EVENTOS DE RATN (right, left, middle, press, etc.)
		- MOSTRAR PARA QU SIRVE EL BOOLEANO DEVUELTO POR LOS MANEJADORES DE RATN (MouseEvent -> IO Bool)
		- MOSTRAR LA INTERRELACIN ENTRE EVENTOS press Y EVENTOS doubleClick

En este ejemplo vamos a controlar cuatro tipos de eventos de ratn sobre un botn: las
pulsaciones del botn izquierdo, los levantamientos del botn derecho, el doble click con
el botn izquierdo y el movimiento. Con un flag podremos bloquear la produccin de eventos
de alto nivel a partir de los de ratn, con lo que podremos ver que con el flag activado
el botn de pruebas no responder cuando cliqueemos sobre l.
-}

main = yahu init
 where init = do {
	; win <- window [title =: "demostracin de eventos de ratn"]
	-- prefabricacin de un label
	; let mklabel str = label [text =: str] win
	-- creamos tres labels
	; [lab1,lab2,lab3] <- mapM mklabel ["n veces botn izquierdo pulsado: ", "n veces botn derecho soltado: ", "n veces doble click izq: "]
	-- prefabricacin de entrys para contadores
	; let mkentry = entry [editable =: False, dimX =: 25, safeValue =: Just 0] win
	-- creamos tres entrys, una por cada contador que vamos a poner
	; [entry1,entry2,entry3] <- sequence [mkentry, mkentry, mkentry]
	-- una entry donde describir el evento actual
	; evento <- entry_ [dimX =: 50, editable =: False] win
	-- objeto al cual instalaremos los manejadores de ratn
	; superficie <- button [text =: "superficie de pruebas"] win
	{- indicador de si se desea que el objeto superficie obtenga eventos de alto nivel a
	partir de los de ratn. Cuando no est chequeado, no se podr pulsar el botn, pues
	inhibiremos entre otras cosas las pulsaciones con el botn izquierdo del ratn, que
	son las que generan el evento de alto nivel "action" de pulsacin del ratn-}
	; propagar <- checkBox [isChecked =: True, text =: "propagar eventos de ratn"] win
	-- handler para los eventos de ratn que incrementan contadores
	; let handler eventtext entry _ = do {
		; evento!:text =: eventtext
		; entry!:safeValue <: (\(Just n)->Just (n+1))
		; prop <- propagar?:isChecked
		; return prop
		}
	{- no vamos a contemplar todos los eventos; para ver como se usan los modificadores
	instalaremos 4 manejadores-}
	; superficie!: on (left $ press mouse) =: handler "PressLeft" entry1
	; superficie!: on (right $ release mouse) =: handler "ReleaseRight" entry2
	; superficie!: on (left $ doubleClick mouse) =: handler "DClickLeft" entry3
	; superficie!: on (move mouse) =: \_->do {
		; evento!:text =: "Moving"
		; propagar?:isChecked
		}
	; win!:layout =: ( (alignRight (lab1 <.< entry1) ^.^
						alignRight (lab2 <.< entry2) ^.^
						alignRight (lab3 <.< entry3))
					 <.< evento )
					 ^.^ superficie ^.^ propagar
	; superficie!:dim =: size 100 100
	}
