import Graphics.UI.Yahu

{- PROPSITO DEL EJEMPLO
			- MOSTRAR EL USO DE ScrollCanvas Y SUS SISTEMAS DE COORDENADAS

Los ScrollCanvas disponen de un "rea virtual" de dibujo, siempre mayor o igual que el
rea que ocupan en pantalla. Si es mayor, se puede navegar por toda la superficie virtual
usando las barras de scroll ad hoc. No obstante, lo pintado sobre dicha superficie no es
durable, sino que se borra al situarse la aplicacin en segundo plano o al ocultarse por
el scrolling. Por eso, para los ScrollCanvas es especialmente importante el evento de
repintado. En este ejemplo se ver la correspondencia entre coordenadas en pantalla,
coordenadas virtuales y el atributo scrollPos. -}

main = yahu init
 where
	init = do {
		; win <- window [title =: "las coordenadas en un ScrollCanvas"]
		; cnv <- scrollCanvas [dim =: size 100 100, scrollSize =: size 1000 1000] win
		-- template para labels
		; let mklabel str = label [text =: str] win
		-- template para entrys
		; let mkentry = entry [editable =: False, dimX =: 200, safeValue =: Just (point 0 0)] win
		-- cada vez que pulsemos sobre el canvas con el ratn aparecer informacin en estos
		-- controles para visualizar las coordenadas.
		; inf_pantalla <- mklabel "Coordenadas en pantalla:"
		; coords_pantalla <- mkentry
		; inf_virtual <- mklabel "Coordenadas virtuales:"
		; coords_virtual <- mkentry
		; inf_esquina <- mklabel "Coords. virtuales de la esquina sup. izq. en la pantalla del canvas:"
		; coords_esquina <- mkentry
		; explicacion <- mklabel "coords. pantalla + coords. esquina = coords. virtuales"
		-- evento de pulsacin con el ratn en el canvas. Extraemos del evento el punto,
		-- que se nos suministrar relativo a la superficie virtual del canvas
		; cnv!:on (left $ press mouse) =: (\MouseEvent{mousePoint=pt}-> do {
			-- convertimos coordenadas virtuales a coordenadas en pantalla
			; scrpt <- calcScrolledPos cnv pt
			-- coordenadas virtuales de la esquina superior izquierda en pantalla del canvas
			; esq <- cnv?:scrollPos
			-- escribimos la informacin pertinente en los entrys
			; coords_pantalla!:safeValue =: Just scrpt
			; coords_virtual!:safeValue =: Just pt
			; coords_esquina!:safeValue =: Just esq
			-- dibujamos un pequeo grfico para ilustrar los datos de los entrys. Se puede
			-- borrar simplemente haciendo scroll sobre el canvas
			; drawCircle cnv pt 3
			; drawRectangle cnv (rectBetween esq pt)
			-- booleano dummy (no nos importa)
			; return True
			})
		; win!:layout =: cnv <.< (alignLeft inf_pantalla ^.^ alignLeft coords_pantalla
								^.^ alignLeft inf_virtual  ^.^ alignLeft coords_virtual
								^.^ alignLeft inf_esquina  ^.^ alignLeft coords_esquina
						^.^ explicacion)
		}
 