import Graphics.UI.Yahu

{- PROPSITO DEL EJEMPLO:
			- EJEMPLO DE USO DE LA BARRA DE ESTADO

Proporcionamos un ejemplo de manipulacin total de la barra de estado
-}

{----------------------------------------------------------------------------------------}

--pequea funcin de utilidad
whenJust :: Maybe a -> IO b -> (a -> IO b) -> IO b
whenJust mb def acc = case mb of
	Nothing -> def
	Just v -> acc v

--genera un conjunto de controles para manejar un atributo
display_action :: (Read a, Show a, Parent w) => w -> String -> IO a -> (a -> IO ()) -> IO Layout
display_action parent infostr get set = do {
	--informacin
	; info <- label [text =: infostr] parent
	--campo de texto en el que manipular el atributo
	; campo <- entry [dimX =: 200] parent
	--botones getter/setter
	; getter <- button [text =: "get"] parent
	; setter <- button [text =: "set"] parent
	--accin get
	; let getcomm = do {
		; val <- get
		; campo!:safeValue =: Just val
		}
	--accin set
	; let setcomm = do {
		; mb <- campo?:safeValue
		; whenJust mb (return ()) set
		}
	--asignamos manejadores de evento
	; getter!:command =: getcomm
	; setter!:command =: setcomm
	; campo!:command =: setcomm
	--asignamos al campo de texto el valor inicial
	; getcomm
	--devolvemos el layout para no tener que rompernos la cabeza luego
	; return (info ^.^ campo ^.^ (getter <.< setter))
	}

main = yahu init
 where init = do {

 	; win <- window [title =: "ejemplo de barra de estado", statusBar =: [VL 1, VL 2, FL 50]]

 	--concrecin de display_action para atributos simples
 	; let display_attr str attr = display_action win str (win?:attr) (\v-> win!:attr =: v)
 	
 	; lay1 <- display_attr "campos en la barra de estado" statusBar
 	; lay2 <- display_attr "contenido de la barra de estado" statusBarFields
 	; lay3 <- display_attr "grip en la barra de estado" statusBarGrip
 	
 	--para manejar el atributo statusBarField
 	; infonum <- label [text =: "nmero de campo"] win
 	; numcampo <- entry [safeValue =: Just 0] win
 	; lay4' <- display_action win "campo especifico de la barra de estado"
 		(do {	--accin get
 			; mb <- numcampo?:safeValue
 			; whenJust mb (return "") (\ind-> win?:statusBarField ind)
 			})
 		(\val-> do {	--accin set
 			; mb <- numcampo?:safeValue
 			; whenJust mb (return ()) (\ind-> win!:statusBarField ind =: val)
 			})
 	; let lay4 = infonum ^.^ numcampo ^.^ lay4'
 	
 	--para mostrar el valor de statusBarFieldsCount
 	; numcampos <- entry [] win
 	; getnumcampos <- button [text =: "nmero de campos en la barra de estado"] win
 	; getnumcampos!:command =: do {
 		; n <- statusBarFieldsCount win
 		; numcampos!:safeValue =: Just n
 		}
 	
 	--asignamos el layout
 	; let margins = marginWidth 5.marginTop.marginLeft.marginRight.marginBottom
 	; win!:layout =: fullFlexMatrix 2 2 (map margins [lay1, lay2, lay3, lay4])
 						<*#< margins (numcampos ^.^ getnumcampos)
 	}

