-- para compilar esto har falta el flag -fglasgow-exts
import Graphics.UI.Yahu
import Graphics.UI.Yahu.H98Exts
import LogWindow

{-PROPSITO DEL EJEMPLO:
			- MOSTRAR EJEMPLOS DE USO DEL MDULO Graphics.UI.Yahu.H98Exts

Veremos varios programas de ejemplo:
	- uso trivial del mdulo. No aporta mucho al uso normal, excepto si uno prefiere un
	  argumento menos en las funciones de creacin y prefiere usar (?::) y (=::) para
	  todo en vez de (?:), (=:), (?:.) y (=:.)
	- uso de las extensiones para layout: si dispusiramos de "syntantic sugar", sera
	  el modo preferido de definir listas de layouts.
-}

{- ejemplo de uso trivial del mdulo: podemos usar las funciones generadoras que
aceptan (PropsList w) en sustitucin de las que aceptan ([ConfigProp w] -> [Prop w]),
y usar (?::) y (=::) en sustitucin de (?:), (=:), (?:.) y (=:.).-}
trivial = do {
	; win <- window [title =: "ejemplo trivial de uso de Graphics.UI.Yahu.H98Exts"]
	; etq1 <- label'' (text =: "etiqueta1" :. justify =:: CenterJust :.
					fontSize =:: 20 :. border =:. RaisedB :. PNil) win
	; etq2 <- label' [justify =:: RightJust, border =:. SunkenB]
					[text =: "etiqueta2", fontSize =:: 15] win
	--la ventana de logs est definida en LogWindow.hs, pero no hace
	--falta comprenderla para comprender el ejemplo.
	; log <- logWindow [dimX =: 400] win
	; txt1 <- etq1?:text
	; logMessage log ("texto: "++txt1++"\n")
	; txt2 <- etq1?::text
	; logMessage log ("texto (otra vez): "++txt2++"\n")
	; bor1 <- etq1?:.border
	; logMessage log ("borde: "++show bor1++"\n")
	; bor2 <- etq1?::border
	; logMessage log ("borde (otra vez): "++show bor2++"\n")
	; let margin = marginLeft.marginRight.marginTop.marginBottom.marginWidth 10
	; win!:layout =: margin etq1 ^*^ margin etq2 ^*^ log
	}

{- ejemplo de cmo se pueden usar las extensiones para layout (tipo Layouts y funcion lays).
En este ejemplo es trivial, pero cuando realmente hace falta usar las funciones lVertical
y lHorizontal (normalmente por parametrizacin del layout), el equipo Layouts/lays supone
una ayuda invaluable-}
uso_layout = do {
	; win <- window [title =: "ejemplo de uso de las extensiones para Layout"]
	; etq <- label [text =: "etiqueta"] win
	; but <- button [text =: "boton"] win
	; sli <- slider' [orient =:. Horiz] [spinRange =: (0,50)] win
	{- pesado de escribir, e imposible escribir cdigo parametrizado en la lista de objetos,
	pues no podemos hacer nada por el estilo de (map toLayout [etq, but, sli]) -}
	; let lay1 = lVertical [toLayout etq, toLayout but, toLayout sli]
	-- menos pesado de escribir, y es ms fcil de escribir cdigo paramtrico con la estructura
	-- Layouts. la funcin lays convierte una estructura Layouts en una lista [Layout].
	; let lay2 = lVertical $ lays (etq :.. but :.. sli :.. LNil)
	-- ambos layouts generan el mismo resultado, pero indudablemente el segundo es mejor
	; win!:layout =: {-lay1-} lay2
	}

main = yahu init
 where init = do {
	; win <- window [title =: "menu de opciones"]
	; but1 <- button [text =: "ejemplo trivial", command =: trivial] win
	; but2 <- button [text =: "ejemplo con layouts", command =: uso_layout] win
	; win!:layout =: but1 ^*^ but2
	}