import Graphics.UI.Yahu

{- PROPSITO DEL EJEMPLO
			- ILUSTRAR EL USO DE onAllMouses
			- MOSTRAR LA FORMA DE PROGRAMAR EVENTOS DE RATN GENRICOS

Este ejemplo muestra los eventos de ratn que se producen sobre un objeto
-}

main = yahu init
 where init = do {
	; win <- window [title =: "visor de eventos de ratn"]
	-- prefabricamos checkboxes
	; let mkcheck str = checkBox [text =: str, isChecked =: False] win
	-- prefabricamos entrys
	; let mkentry = entry_ [editable =: False, dimX =: 100] win
	-- checkboxes para los campos del tipo Modifiers
	; [ctrl,alt,shift] <- mapM mkcheck ["Ctrl Pulsado", "Alt Pulsado", "Shift Pulsado"]
	-- entrys para mouseButton, mouseAction, mousePoint y mouseWheelRotation
	; [but,act,pointx,pointy, wheel] <- sequence (take 5 (repeat mkentry))
	-- objeto al que interceptaremos eventos de ratn
	; superficie <- panel [dimY =: 100, bgColor =: red] win
	-- instalamos el manejador de evento en *todos* los casos con onAllMouses
	; onAllMouses (\MouseEvent{mouseButton=mb,mouseAction=ma,mousePoint=mp
					,mouseModifiers=mm,mouseWheelRotation=mw}
					-> do {
		-- mostramos Modifiers
		; ctrl!:isChecked =: ctrlPressed mm
		; alt!:isChecked =: altPressed mm
		; shift!:isChecked =: shiftPressed mm
		-- mostramos wheeling
		; wheel!:text =: if ma==MouseWheel then (if mw then "WheelUp" else "WheelDown")
						 else "-"
		-- mostramos posicin
		; pointx!:text =: show (pointX mp)
		; pointy!:text =: show (pointY mp)
		-- mostramos el tipos de evento
		; act!:text =: show ma
		-- mostramos el botn con el que ha ocurrido el evento
		; but!:text =: if ma `elem` [MouseMove, MouseEnter, MouseExit, MouseWheel]
						then "-" else show mb
		-- dummy; no nos importa si los eventos de ratn se propagan o no.
		; return True
		})
		superficie
	; win!:layout =: ((ctrl <.< alt <.< shift <.< wheel)
						^.^ (but <.< act <.< pointx <.< pointy))
						^*^ superficie
	}