{-El error se produce despues del evento windowDestroy y antes del evento windowDelete
de la Window, cuando ya se han producido sin contratiempos esos eventos en las
floatingwindow, dialogs y panels (comprobado), por lo que no se produce a causa de
eventos de timing perdidos, pues en esa situacin los evthadler de los alarm estan
todavia vivos. Tampoco se produce porque el evthandler del timer todavia vivo ejecute un
handler que referencia a un edit hijo de la ventana ya destruida (comprobado)-}
import qualified Graphics.UI.WXH as W
import Graphics.UI.Yahu.All
import MinePanel
import Monad(when)
import System.Directory

main = yahu init
	where init = do {
		---------------------------------------------------------------------------
		--VENTANA PRINCIPAL
		; let basetitle = "Buscaminas"
		; win <- window [resizeBorder =: False, enableMaximizeButton =: False
			, title =: basetitle, statusBarGrip =: False, statusBar =: [VL 1, FL 50] ]
		; mbico <- bitmapLoad "hsicon.ico" TypeICO
		; case mbico of
			Nothing -> return ()
			Just ico -> do {
				; setIcon win ico
				; destroy ico
				}
		
		---------------------------------------------------------------------------
		--VENTANA DE AYUDA
		; ayudita <- floatingWindow [title =: "Ayuda"] win
		--ya se destruir cuando muera la Window padre. Si la cerramos, simplemente la ocultamos
		; ayudita!:on close =: (ayudita!:shown =: False)
		; info <- edit [dim =: size 300 100, editable =: False] ayudita
		; writeText info "Para empezar un nuevo juego, pulse F2.\n\n"
		; writeText info "Para descubrir una celda, pinche en ella.\n\n"
		; writeText info "Puede marcar como minada una celda pulsndola con el botn derecho del ratn.\n\n"
		; writeText info "Si est especulando sobre cmo pueden estar dispuestas las minas, puede usar las marcas que puede habilitar pulsando otra vez con el botn derecho sobre una celda marcada como mina. Pulsando otra vez, la deja como estaba al principio.\n\n"
		; writeText info "Si ha decidido que ya ha encontrado todas las minas alrededor de una celda ya descubierta, puede probar suerte haciendo doble click con el botn derecho sobre ella.\n\n"
		; writeText info "Recuerde que el intrngulis del juego consiste en hacerlo lo ms rpido posible, sin pensar. Cuanto menos tiempo tarde, mejor.\n\n"
		; meheenterado <- button [text =: "Aceptar", command =: (ayudita!:shown =: False)] ayudita
		; ayudita!:layout =: info ^*.^ meheenterado
		
		---------------------------------------------------------------------------
		--BARRA DE PROGRESO DURANTE LA CREACION DE CAMPOS DE MINAS
		; esperandito <- floatingWindow' [caption =:. True] [title =: "Creando nuevo..."
			, resizeBorder =: False] win
		; esperando <- gauge' [orient =:. Horiz, gaugeSmooth =:. True]
			[dim =: size 200 20] esperandito
		; esperandito!:layout =: esperando
		
		---------------------------------------------------------------------------
		--DIALOGO PARA CUSTOMIZAR LOS PARAMETROS DEL PANEL
		; chgDialog <- dialog [title =: "Personalizar parmetros", resizeBorder =: False] win
		--con este panel nos podremos mover con tabuladores por los controles
		; tabMoving <- panel [] chgDialog
		; infoAltoCh <- label [text =: "  Alto:"] tabMoving
		; altoCh <- entry [] tabMoving
		; infoAnchoCh <- label [text =: "  Ancho:    "] tabMoving
		; anchoCh <- entry [] tabMoving
		; infoNumCh <- label [text =: "  Minas:"] tabMoving
		; numCh <- entry [] tabMoving
		; aceptarCh <- button [text =: "Aceptar"] tabMoving
		; cancelarCh <- button [text =: "Cancelar"] tabMoving
		; let aceptar_input = do {
			--esto quedara ms elegante combinando las mnadas IO y Maybe, pero as vale
			; mbalto <- altoCh?:safeValue
			; mbancho <- anchoCh?:safeValue
			; mbnum <- numCh?:safeValue
			; chgDialog!:value =: do {
				--usamos la notacin "do" para mayour comodidad
				; alto <- mbalto
				; ancho <- mbancho
				; num <- mbnum
				; if alto>0 && alto>0 && num>=0
				  then Just (Size ancho alto, num) else Nothing
				}
			; endModal chgDialog
			}
		; aceptarCh!:command =: aceptar_input
		; altoCh!:command =: aceptar_input
		; anchoCh!:command =: aceptar_input
		; numCh!:command =: aceptar_input
		; cancelarCh!:command =: do {
			; chgDialog!:value =: Nothing
			; endModal chgDialog
			}
		--podemos hacer esto porque aplicamos marginsY slo a Entry Int y marginsX a Button
		; let marginsY = marginWidth 15.marginTop.marginBottom
		; let marginsX = marginWidth 10.marginRight.marginLeft
		; let listamatriz = [alignLeft infoAltoCh, marginsY altoCh, alignLeft infoAnchoCh
			, marginsY anchoCh, alignLeft infoNumCh, marginsY numCh]
		; chgDialog!:layout =: insertPanel tabMoving
			(matrix 2 3 listamatriz <*< (marginsX aceptarCh ^#^ marginsX cancelarCh))

		---------------------------------------------------------------------------
		--MENU DE JUEGO
		; menuj <- inBarMenuAppend [title =: "&Juego"] win
		; let genmenuj = MnInBar menuj
		; nuevo <- menuLabelAppend [
			text =: "&Nuevo\tF2"
			, statusBarHelp =: "Nuevo juego..."] genmenuj
		; menuSeparatorAppend genmenuj
		; principiante <- menuLabelAppend [
			text =: "&Principiante"
			, statusBarHelp =: "tablero 8*8/10"] genmenuj
		; intermedio <- menuLabelAppend [
			text =: "&Intermedio"
			, statusBarHelp =: "tablero 16*16/40"] genmenuj
		; experto <- menuLabelAppend [
			text =: "&Experto"
			, statusBarHelp =: "tablero 16*30/99"] genmenuj
		; personalizado <- menuLabelAppend [
			text =: "&Personalizado"
			, statusBarHelp =: "tablero personalizado"] genmenuj
		; menuSeparatorAppend genmenuj
		; menuLabelAppend [
			text =: "&Salir\tCtrl-Q"
			, statusBarHelp =: "terminar el juego"
			, command =: quit] genmenuj

		---------------------------------------------------------------------------
		--MENU DE AYUDA
		; menua <- inBarMenuAppend [title =: "&Ayuda"] win
		; let genmenua = MnInBar menua
		; menuLabelAppend [text =: "&Ayuda\tCtrl-A"
			, statusBarHelp =: "instrucciones de uso"
			, command =: (ayudita!:shown =: True)] genmenua
		
		---------------------------------------------------------------------------
		--CAMPO DE MINAS INICIAL
		; initmp <- minePanel cellsize (size 8 8) nothingGauge win
		; initmp!:numMines =: 10
		
		---------------------------------------------------------------------------
		--REFERENCIA AL PANEL DE MINAS ACTUAL
		--como el de un MinePanel es fijo, si queremos poder jugar con varios tamaos
		--tendremos que aadir un nivel de indireccin
		; refmp <- state [value =: initmp]
		; let withMPRef acc = (refmp?:value) >>= acc

		---------------------------------------------------------------------------
		--RESTO DE CONTROLES USADOS EN LA APLICACION
		--botn de snapshot
		; snapshot <- button [text =: "Foto de Recuerdo"] win
		; snapshot!:command =: (do {
			; fileName <- getFileName
			; screenShot win fileName TypeJPEG >> return ()
			}) `catch` (\_->return ())
		--tiempo transcurrido
		; paneltiempo <- entry' [justify =:. RightJust] [safeValue =: Just 0
		  , editable =: False, fontWeight =: FontWeightBold, fontSize =: 18] win
		--timer que actualiza el tiempo transcurrido
		; relojero <- alarm [alarmInterval =: 1000, alarmType =: Cyclic]
		; relojero!:command =: (do {
			--; putStr "uno\n"
			; paneltiempo!:safeValue <: \(Just val)-> Just (val+1)
			--; putStr "dos\n"
			})
		--; win!:on beforeDestroy =: putStr "WIN\n"
		--; W.windowAddOnDelete (toWXWin win) (putStr "win\n")
		--flags colocados
		; panelflags <- entry' [justify =:. RightJust] [safeValue =: Just 70
		  , editable =: False, fontWeight =: FontWeightBold, fontSize =: 18] win
		--botn de reset
		; nuevo' <- button [text =: "Nuevo", fontWeight =: FontWeightBold] win
		--botn de snapshot

		---------------------------------------------------------------------------
		--SUBRUTINAS
		--asignamos layout
		; let minelayout mp{-::MinePanel-} = do {
			; let margins = marginWidth 10.marginTop.marginBottom.marginLeft.marginRight
			; let vSp = voidSpace 3 3
			; win!:layout =: vSp ^.^ (vSp <.< paneltiempo <.< vSp <.< (snapshot ^.^ vSp
				^.^ nuevo') <.< vSp <.< panelflags <.< vSp) ^.^ margins mp
			; let Size sx sy = cellsize
			; let Size cx cy = cellDim mp
			--hay que reasignar el tamao del panel, pues al no tener layout, se calcula
			--su tamao mnimo en (Size 0 0)
			; mp!:dim =: size (sx*cx) (sy*cy)
			}
		--cambiamos el ttulo, para que refleje el estado de juego
		; let changetitle mp{-::MinePanel-} = do {
			; st <- mpState mp
			; win!:title =: basetitle++" ("++show st++")"
			}
		--actualizamos nmero de celdas descubiertas
		; let shownakeds mp{-::MinePanel-} = do {
			; nakeds <- nakedCells mp
			; win!:statusBarField 1 =: show (numCells mp - nakeds)
			}
		--actualizamos nmero de flags puestos (manejador de evento del evento flagged)
		; let showflags mp{-::MinePanel-} = \unflagmas _-> do {
			; panelflags!:safeValue <:
				\(Just n)->Just (n + if unflagmas then -1 else 1)
			}
		--paramos el contador de segundos
		; let fin mp{-::MinePanel-} = do {
			; relojero!:paused =: True
			; shownakeds mp
			; changetitle mp
			; panelflags!:safeValue =: Just 0
			}
		--reseteamos el panel y los indicadores
		; let reset mp{-::MinePanel-} = do {
			; relojero!:paused =: True
			; nuevo'!:text <<: \preservar-> do {
				; nuevo'!:text =: "Reseting"
				; resetMP mp
				; return preservar
				}
			; changetitle mp
			; nM <- mp?:numMines
			; panelflags!:safeValue =: Just nM
			; paneltiempo!:safeValue =: Just 0
			; win!:statusBarField 1 =: show (numCells mp)
			}
		--asignamos los eventos del panel
		; let setcallbacks mp{-::MinePanel-} = do {
			; mp!:on pressed =: \_-> shownakeds mp
			; mp!:on flagged =: showflags mp
			; mp!:on startGame =: \_-> do {
				; changetitle mp
				; relojero!:paused =: False
				}
			; mp!:on exploded =: \_-> fin mp
			; mp!:on winGame =: fin mp
			}
		--generamos un nuevo panel
		; let newMP siz{-::Size-} numminas{-::Int-} oldmp{-::MinePanel-} = do {
			; relojero!:paused =: True
			; win!:title =: basetitle
			; destroy oldmp
			{- Por alguna extraa razn:
   				-al crear el minePanel, wxwindows encoge la ventana arbitrariamente y
   				esconde todos los controles, y aunque he intentado que los entry y el
   				botn sigan ah invocando reLayout o reasignando un layout transitorio
   				sin el minePanel, esos apaos no sirven.
   				-parece que algunos atributos de ventanas en wxwindows, si quieres que
   				funcionen inmediatamente (dentro del mismo manejador de evento), hay
   				que asignarlos ms de una vez. En particular, para forzar que se vea
   				el botn mientras todo lo dems ha sido escondido (como se dice hace
   				ms adelante), hay que asignar el texto dos veces.-}
			; Point x y <- win?:pos
			; esperandito!:pos =: Point (x+50) (y+25)
			--mostramos la barra de progreso
			; esperandito!:shown =: True
			; newmp <- minePanel cellsize siz (Just esperando) win
			; esperandito!:shown =: False
			; newmp!:numMines =: numminas
			; refmp!:value =: newmp
			; setcallbacks newmp
			--asignamos el texto una vez, para que surta efecto la segunda vez en "reset"
			; nuevo'!:text <: id
			; reset newmp
			; minelayout newmp
			}
		--ahorra el reset cuando es posible
		; let ahorraReset mp{-::MinePanel-} = do {
			; st <- mpState mp
			; when (st/=Reset) (reset mp)
			}
		--slo cambia los parmetros ms computacionalmente costosos del MinePanel en caso
		--de ser necesario
		; let ahorrador newsize{-::Size-} newmines{-::Int-} mp{-::MinePanel-} = do {
			; if cellDim mp==newsize then do {
				; ahorraReset mp
				; panelflags!:safeValue =: Just newmines
				; mp!:numMines =: newmines
			} else
				newMP newsize newmines mp
			}
		--tamao a la carta
		; let customSize mp{-::MinePanel-} = do {
			--populamos los entry's del dilogo con los valores actuales
			; oldnum <- mp?:numMines
			; let Size oldx oldy = cellDim mp
			; altoCh!:safeValue =: Just oldy
			; anchoCh!:safeValue =: Just oldx
			; numCh!:safeValue =: Just oldnum
			; Point x y <- win?:pos
			; chgDialog!:pos =: Point (x+75) (y+75)
			; res <- showModal chgDialog
			; case res of
				Nothing -> return ()
				Just (Size newx newy, newmines) -> do {
					--"segamos" los valores para que no sean mayores que unos estndares:
					--30 de ancho, 16 de alto, y como mximo un tercio con minas
					; let newX = min newx maxSizeX
					; let newY = min newy maxSizeY
					; let newSize = Size newX newY
					; let newNumMines = min newmines ((newX*newY) `div` 3)
					; ahorrador newSize newNumMines mp
					}
			}

		---------------------------------------------------------------------------
		--ASIGNACION DE MANEJADORES DE EVENTOS CON SUBRUTINAS
		--eventos varios
		; principiante!:command =: withMPRef (ahorrador (size 8 8) 10)
		; intermedio!:command =: withMPRef (ahorrador (size 16 16) 40)
		; experto!:command =: withMPRef (ahorrador (size 30 16) 99)
		; personalizado!:command =: withMPRef customSize
		; nuevo!:command =: withMPRef ahorraReset
		; nuevo'!:command =: withMPRef ahorraReset

		---------------------------------------------------------------------------
		--INICIALIZACIN DEL PANEL
		; setcallbacks initmp
		; reset initmp
		; minelayout initmp
		}

--necesario debido a la puetera restriccin de tipos H98...
nothingGauge :: Maybe Gauge
nothingGauge = Nothing

--tamao de celda
cellsize = size 16 16

--dimensiones mximas en celdas del campo de minas
maxSizeX = 30
maxSizeY = 16

--conseguimos un nombre de fichero nico cada vez que lo llamamos (eso s, puede tardar
--bastante si hay ya "muchos")
getFileName :: IO String
getFileName = do {
	; dir <- getCurrentDirectory
	; let getFileName' n = do {
		--para hacer nombres del estilo snp00, snp01, etc.
		; let addCeros long str = let lstr = length str in
			if lstr >= long then str else take (long-lstr) (repeat '0') ++ str
		; let actual = dir++"\\MineSweeper"++addCeros 2 (show n)++".jpg"
		; notok <- doesFileExist actual
		; if notok then getFileName' (n+1) else return actual
		}
	; getFileName' 0
	}
